#ifndef _CEGOEXPOUTSTREAM_H_INCLUDED_
#define _CEGOEXPOUTSTREAM_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CegoExpOutStream.h
// ------------------
// Cego export outstream description
//
// Design and Implementation by Bjoern Lemke
//
// (C)opyright 2000-2013 Bjoern Lemke
//
// INTERFACE MODULE
//
// Class: CegoExpOutStream
// 
// Description: 
//
// Status: QG-2.6
//
///////////////////////////////////////////////////////////////////////////////

// base includes
#include <lfcbase/Chain.h>
#include <lfcbase/ListT.h>

// xml includes
#include <lfcxml/Element.h>
#include <lfcxml/XMLOutStream.h>

// cego includes
#include "CegoDistManager.h"
#include "CegoObjectCursor.h"
#include "CegoField.h"

class CegoExpOutStream : public XMLOutStream {
    
public:
    
    CegoExpOutStream(int tabSetId, const Chain& tableName, const ListT<CegoField>& schema, CegoDistManager* pGTM);
    ~CegoExpOutStream();
    
    Element* getFirst();
    Element* getNext();
    
private:

    Element* getRowElement(ListT<CegoField>& schema);
    
    CegoDistManager* _pGTM;
    CegoObjectCursor* _pOC;
    ListT<CegoField> _schema;
    int _tabSetId;
};

#endif




