///////////////////////////////////////////////////////////////////////////////
//                                                         
// CegoProcCursorCloseStmt.cc  
// --------------------------                                                     
// Cego procedure cursor close statement implementation
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2013 Bjoern Lemke
//
// IMPLEMENTATION MODULE
//
// Class: CegoProcCursorCloseStmt
// 
// Description:
//
// Status: QG-2.6
//
///////////////////////////////////////////////////////////////////////////////

// base includes
#include <lfcbase/Exception.h>

// cego includes
#include "CegoSelect.h"
#include "CegoProcCursorCloseStmt.h"

CegoProcCursorCloseStmt::CegoProcCursorCloseStmt(CegoProcCursor *pCur,CegoProcBlock *pBlock) : CegoProcStmt(pBlock)
{
    _pCur = pCur;
}

CegoProcCursorCloseStmt::~CegoProcCursorCloseStmt()  
{
}

CegoException CegoProcCursorCloseStmt::execute()
{
    if ( _pCur )
    {
	_pCur->close();
    }
    return NONE_EXCEP;
}

Chain CegoProcCursorCloseStmt::toChain(const Chain& indent) const
{
    Chain s;

    s += indent + Chain("close ");
    s += _pCur->getName();
    return s;
}
